<?
/*
###############################
#
# IMAP Mail Check plugin script for CC
# verified with CC versions 1.9x
# http://www.jkirkpatrick.org/index.php
#
###############################
#
# Date: July 8, 2004
# Web: http://www.jkirkpatrick.org/index.php
# Mail: plugins@jkirkpatrick.org
#
###############################
*/
class mc_imap
{
    var $domain;
    var $password;
    var $username;
    var $mbox;
    var $foward;
    var $no_mail;
    var $log_mbox;
    var $log_domain;
    var $nix_time;
    var $table_mbox;
    var $table_domain;
    var $max_per_session=500;
    function mc_imap($domain, $username, $password, $foward='', $no_mail=0, $erase=0, $log_mbox, $table_mbox, $log_domain, $table_domain)
    {
        $this->domain=$domain;
        $this->username=$username;
        $this->password=$password;
        $this->foward=$foward;
        $this->no_mail=$no_mail;
        $this->delete=$erase;
        $this->log_mbox=$log_mbox;
        $this->log_domain=$log_domain;
        $this->table_mbox=$table_mbox;
        $this->table_domain=$table_domain;
        $this->nix_time=time();
    }
    function imap_modcheck()
    {
        if(function_exists('imap_open'))
            return TRUE;
        else
            return FALSE;
    }
    function disconnect()
    {
        return imap_close($this->mbox);
    }
    function connect($port=143, $ssl=0, $pop3=0)
    {
        if(!$pop3)
        {
           if($ssl)
              $opt='/imap/ssl/novalidate-cert';
           else    
              $opt='/imap';
        }else{
           if($ssl)
              $opt='/pop3/ssl/novalidate-cert';
           else    
              $opt='/pop3';
        }
        $this->mbox = @imap_open("{".$this->domain.":".$port.$opt."}INBOX", $this->username, $this->password);
        if(!$this->mbox)
        {
            echo "<p align=center><font color=#FF0000>".$this->last_error()."</font></p>\n";
            return FALSE;
        }
        else
            return TRUE;
    }
    function ping()
    {
        return @imap_ping($this->mbox);
    }
    function find_bounced_to($msgbody)
    {
        echo "<h2>Begin Check</h2>\n<p align=left>";
        if(preg_match_all('^([_a-zA-Z0-9-]+)(\.[_a-zA-Z0-9-]+)*@([a-zA-Z0-9-]+)(\.[a-zA-Z0-9-]+)*(\.[a-zA-Z]{2,4})^', $msgbody, $reg)===FALSE)
        {
          echo "<font color=#FF0000>mailcheck: no pattern match.</font><br>\n";
          return FALSE;
        }
        if(!is_array($reg[0]))
        {
          echo "<font color=#FF0000>mailcheck: return value not an array.</font><br>\n";
          return FALSE;
        }
        echo "mailcheck: Searching";
        foreach($reg[0] as $key=>$value)
        {
               if($value)
               if(@mysql_num_rows(@mysql_query("SELECT `email` FROM `".mysql_prefix."users` WHERE `email`='$value'")))
               {
                  echo "&nbsp;&nbsp;<font color=#00FF00>Owner FOUND...</font></p><hr>\n";
                  return $value;
               }else{
                  echo ".";
               }
        }
        echo "&nbsp;&nbsp;<font color=#FF0000>Could not resolve the email address in the database.</font></p>\n<hr>\n";
        return FALSE;
    }
    function handle_bouncers()
    {
        echo "<p align=left>Connection sucessful, ".$this->message_count()." messages found.</p>\n";
        $found=0;
        $notfound=0;
        for ($i = 1; $i <= $this->message_count(); $i++)
        {
            unset($fromname);
            unset($fromaddress);
            unset($toname);
            unset($toaddress);
            $body = imap_body($this->mbox, $i);
            $header = imap_headerinfo($this->mbox, $i, 80, 80);
            $subject= $header->fetchsubject;
            $from = $header->from;
            foreach ($from as $id => $object) {
                $fromname = $object->personal;
                $fromaddress = trim($object->mailbox . "@" . $object->host);
            }
            $test=$from[0]->mailbox.'@'.$from[0]->host;
            $to = $header->to;
            foreach($to as $id => $object)
            {
                $toname=$object->personal;
                $toaddress=trim($object->mailbox . "@" . $object->host);
            }
            if($this->log_mbox || $this->log_domain || $this->no_mail)
            {
              $bouncer=$this->find_bounced_to($body);
            }
            if($bouncer)
            {
                $split=explode('@', $bouncer);
                if($this->no_mail)
                    $this->nomail_bouncer($bouncer);
                if($this->delete)
                    imap_delete($this->mbox, $i);
                if($this->log_mbox)
                    $this->log_mbox_hit($bouncer);
                if($this->log_domain)
                    $this->log_domain_hit($split[1]);
                $found++;
            }else{
                $notfound++;
            if($this->foward)
                $this->foward($body,$fromname,$fromaddress,$subject,$toname,$toaddress);
            if($this->delete)
                imap_delete($this->mbox, $i);
            }
            unset($bouncer);
            if($i >=$this->max_per_session)
              break;
        }
    if($this->delete)
        imap_expunge($this->mbox);
    echo "<p align=left><font color=#0000FF>Summary: $found user bounces found, $notfound unknown eMails found</font></p>\n"; 
    }
    function log_mbox_hit($mbox)
    {
        $mbox=strtolower($mbox);
        $result=@mysql_query("SELECT `mailbox` FROM `".$this->table_mbox."` WHERE `mailbox`='".$mbox."'");
        if(mysql_num_rows($result) > 0)
            @mysql_query("UPDATE `".$this->table_mbox."` SET `count`=count+1, `last_bounce`='".$this->nix_time."' WHERE `mailbox`='".stripslashes($mbox)."'");
        else
            @mysql_query("INSERT INTO `".$this->table_mbox."` SET `count`='1', `last_bounce`='".$this->nix_time."', `mailbox`='".stripslashes($mbox)."'");
    }
    function log_domain_hit($domain)
    {
        $domain=strtolower($domain);
        $result=@mysql_query("SELECT `domain` FROM `".$this->table_domain."` WHERE `domain`='".$domain."'");
        if(mysql_num_rows($result) > 0)
            @mysql_query("UPDATE `".$this->table_domain."` SET `count`=count+1, `last_bounce`='".$this->nix_time."' WHERE `domain`='".stripslashes($domain)."'");
        else
            @mysql_query("INSERT INTO `".$this->table_domain."` SET `count`='1', `last_bounce`='".$this->nix_time."', `domain`='".stripslashes($domain)."'");
        echo mysql_error();
    }
    function nomail_bouncer($address)
    {
        @mysql_query("UPDATE `".mysql_prefix."users` SET `email_setting`='0' WHERE `email`='$address'");
    }
    function foward($body,$fromname,$fromaddress,$subject,$toname,$toaddress)
    {
        if(strrpos($this->username, '@')===FALSE)
            $address=$this->username."@".$this->domain;
        else
            $address=$this->username;
        $message = "Email fowarder at address ".$address."
From: $fromname <$fromaddress>
To: $toname <$toaddress>
Subject: $subject
        Please notify sender of correct mailing address. If this is a bounced email, forward it to jkirkpatrick.org so the plugin can be updated to find the email address of this originating domain.

Thank You,
IMAP Mail Check Cron Job
".strtoupper(domain)."
#################ORIGINAL MESSAGE BODY########################
$body";

        $newsub = "Fwd: $subject";
        $fname = "IMAP Mail Check - ".strtoupper(domain);
        $mail = array('tname' => 'Webmaster\Webmistress',
        'to' => $this->foward,
        'fname' => $fname,
        'from' => $address,
        'subject' =>$subject,
        'body' => $message);
        $this->mail_to($mail);
    }
    function mail_to($mail)
    {
        $header = "Reply-To: Webmaster/Webmistress <".$this->foward.">\r\n";
        $header .= "From: IMAP Mail Check <".$mail['from'].">\r\n";
        $header .= "X-Mailer: Cash Crusader - IMAPMC\r\n";
        $header .= "Content-Type: text/plain\r\n";
        mail($this->foward, $mail['subject'], stripslashes($mail['body']), $header);
    }
    function message_count()
    {
        return imap_num_msg($this->mbox);
    }
    function last_error()
    {
        return imap_last_error();
    }
}
